=== debian/changelog ===
pytorch (1.7.1-7) unstable; urgency=medium

  * Remove B-D libunwind.
  * Update autopkgtest.

 -- Mo Zhou <lumin@debian.org>  Thu, 11 Feb 2021 15:13:27 +0800

pytorch (1.7.1-6) unstable; urgency=medium

  * Make B-D:libunwind-dev specific to amd64,arm64,armhf,ppc64el.

 -- Mo Zhou <lumin@debian.org>  Mon, 01 Feb 2021 14:35:46 +0800

pytorch (1.7.1-5) unstable; urgency=medium

  * Add libunwind-dev to avoid weird FTBFS (due to missing header).
  * Require libonnx-dev (>= 1.7.0+dfsg-3) to avoid FTBFS (Closes: #980636)

 -- Mo Zhou <lumin@debian.org>  Wed, 27 Jan 2021 18:38:00 +0800

pytorch (1.7.1-4) unstable; urgency=medium

  * Allow more autopkgtest cases to fail on armhf.

 -- Mo Zhou <lumin@debian.org>  Sat, 02 Jan 2021 17:17:42 +0800

pytorch (1.7.1-3) unstable; urgency=medium

  * Build against generic BLAS/LAPACK instead of OpenBLAS.

 -- Mo Zhou <lumin@debian.org>  Sun, 27 Dec 2020 19:47:18 +0800

pytorch (1.7.1-2) unstable; urgency=medium

  * Update autopkgtest scripts.

 -- Mo Zhou <lumin@debian.org>  Sun, 20 Dec 2020 13:28:22 +0800

pytorch (1.7.1-1) unstable; urgency=medium

  * New upstream version 1.7.1
  * Disable OpenMPI in the distributed functionality of pytorch.
    + Regenerate Autopkgtest control file after removing OpenMPI support.
    + Explicitly specify USE_MPI=OFF in d/rules.
  * Add missing runtime deps to autopkgtest and refresh.
    - Autopkgtest: allow several tests to fail. (Closes: #974210)
    + Revamp of the python part of autopkgtest and add the missing B-Ds.
  * Get rid of the symbols control file. (Closes: #977533)

 -- Mo Zhou <lumin@debian.org>  Wed, 16 Dec 2020 20:58:19 +0800

pytorch (1.7.0-2) unstable; urgency=medium

  * Patch cmake to fix ppc64el and s390x FTBFS, really disabling XNNPACK.
  * d/rules: Only enable QNNPACK on amd64.
  * Refresh symbols control file for amd64 to fix amd64 FTBFS.

 -- Mo Zhou <lumin@debian.org>  Tue, 24 Nov 2020 20:10:34 +0800

pytorch (1.7.0-1) unstable; urgency=medium

  * Make B-D:libxnnpack-dev amd64 and arm64 arch-specific.
  * Make USE_DISTRIBUTED and the corresponding Build-Depends specific
    to the 64-bit architectures: amd64 arm64 ppc64el mips64el s390x.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Tue, 24 Nov 2020 12:59:42 +0800

pytorch (1.7.0-1~exp1) experimental; urgency=medium

  * New upstream version 1.7.0
  * Add missing python deps for the autopkgtest :: python cases.
  * Mark libideep-dev/libdnnl-dev & USE_MKLDNN as amd64,arm64,ppc64el-specific.
  * Patch cmake to strip third-party directory includes/checks.
  * Turn off USE_PYTORCH_QNNPACK on non-amd64 architectures.
  * Update embedded foxi to snapshot 4aba696ec8f31794fd42880346dc586486205e0a.
  * Rebase and refresh existing patches.
  * Rename binary packages following the SOVERSION bump.
  * Update dirtyhack.patch and add new B-D libnop-dev.
  * Refresh symbols control file for amd64.
  * Autopkgtest: refresh C++ unit test list.
  * Autopkgtest: refresh the list of python unit tests.
  * Refresh d/copyright for the new upstream release.

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Nov 2020 14:30:28 +0800

pytorch (1.6.0-5) unstable; urgency=medium

  * Revert introduction of unnecessary python3 dependencies.
  * Mute dh_auto_configure which triggers incorrect mixed python{3.8,3.9} build.
  * Refresh symbols control file.
  * Fix autopkgtest regenerator and refresh d/tests/control.
  * Let python3-torch also Recommend build-essential (for JIT functionality).

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Oct 2020 00:16:57 +0800

pytorch (1.6.0-4) unstable; urgency=medium

  [ Steffen Möller ]
  * Added d/u/metadata file

  [ Mo Zhou ]
  * Address regression bug in dependency data. (Closes: #972540)
  * Add LaTeX bibliography information to upstream/metadata.

 -- Mo Zhou <lumin@debian.org>  Tue, 20 Oct 2020 17:59:38 +0800

pytorch (1.6.0-3) unstable; urgency=medium

  * Change maintainer mail address into debian-ai@l.d.o
  * d/rules: Explicitly specify build with default python3.
  * Refresh symbols control file.
  * Use those defined-but-unused control variables.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 16:12:46 +0800

pytorch (1.6.0-2) experimental; urgency=medium

  * Let python3-torch recommend libtorch-dev (= ${binary:Version}).
  * Let python3-torch recommend ninja-builds (Building PyTorch C++ Extension).
  * Add debian/tests/run-cpptest.sh for manually running tests.
  * Refresh test program list for gencontrol-pytest.sh and add run-pytest.sh
  * Filter out CUDA tests from gencontrol-pytest.sh.
  * Remove the unnecessary USE_OPENCV=ON override from the patch
  * Enable DNNL/ideep integration and refresh symbols control file.
  * Remove "-" signs from rules and add symlink in python3-torch.
  * Fix the stronger-dependency-implies-weaker problem for python3-torch.
  * Fix the globbing-patterns-out-of-order problem for d/copyright.
  * Refresh the shebang patch.
  * Sort tests in gencontrol-cpptest.sh and regenerate tests/control.
  * Toggle USE_ZSTD=ON and add the corresponding patches and B-Ds.

 -- Mo Zhou <lumin@debian.org>  Mon, 07 Sep 2020 14:27:37 +0800

pytorch (1.6.0-1) experimental; urgency=medium

  * New upstream version 1.6.0
  * Refresh shebang.patch.
  * Significantly rebase dirtyhack.patch as most changes have been upstreamed.
  * Remove dont-break-dev-null.patch. fixed upstream.
  * Add some missing Depends for libtorch-dev.
  * Stripping the quotes in ONNX_NAMESPACE to fix build failure.
  * Add libtensorpipe-dev to Build-Depends.
  * Rename libtorch1 -> libtorch1.6 and refresh symbols control file.
  * dirtyhack.patch: Deal with the fmt and tensorpipe libraries.
  * rules: use SOVERSION variable and update the install target.
  * Update d/copyright and apply wrap-and-sort.
  * Put proper symlinks to usr/lib/python3*/dist-packages/torch/lib.

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 19:41:58 +0800

pytorch (1.5.1-1) experimental; urgency=medium

  * New upstream version 1.5.1

