=== debian/control ===
Source: pytorch
Section: science
Homepage: https://pytorch.org/
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-exec,
               dh-python,
               googletest,
               libasio-dev,
               libavcodec-dev,
               libbenchmark-dev,
               libblas-dev,
               libcpuinfo-dev,
               libdnnl-dev [amd64 arm64 ppc64el],
               libeigen3-dev,
               libfmt-dev,
               libfp16-dev,
               libfxdiv-dev,
               libgflags-dev,
               libgloo-dev [amd64 arm64 ppc64el mips64el s390x],
               libgoogle-glog-dev,
               libideep-dev [amd64 arm64 ppc64el],
               liblapack-dev,
               libleveldb-dev,
               liblmdb-dev,
               libnop-dev,
               libonnx-dev (>= 1.7.0+dfsg-3),
               libopencv-dev,
               libprotobuf-dev,
               libprotoc-dev,
               libpsimd-dev,
               libpthreadpool-dev,
               libsleef-dev,
               libsnappy-dev,
               libtensorpipe-dev,
               libxnnpack-dev [amd64 arm64],
               libzmq3-dev,
               libzstd-dev,
               ninja-build,
               ocl-icd-opencl-dev,
               protobuf-compiler,
               pybind11-dev,
               python3,
               python3-all,
               python3-all-dev,
               python3-cffi,
               python3-distutils,
               python3-numpy,
               python3-onnx,
               python3-pybind11,
               python3-setuptools,
               python3-yaml

Package: python3-torch
Section: python
Architecture: any
Depends: libtorch1.7 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
# PyTorch's JIT (C++ Extension) functionality needs development files/tools.
Recommends: libtorch-dev (= ${binary:Version}), build-essential, ninja-build,
 pybind11-dev,
Suggests: python3-hypothesis, python3-pytest
Provides: ${python3:Provides}
Description: Tensors and Dynamic neural networks in Python with strong GPU acceleration
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch and Caffe2 (Python interface).

Package: libtorch-dev
Section: libdevel
Architecture: any
Depends: libgflags-dev,
         libgoogle-glog-dev,
         libtorch1.7 (= ${binary:Version}),
         python3-all-dev,
         ${misc:Depends}
Description: Tensors and Dynamic neural networks in Python with strong GPU acceleration
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch and Caffe2 (Development files).

Package: libtorch1.7
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: libopenblas0 | libblis3 | libatlas3-base | libmkl-rt | libblas3,
Description: Tensors and Dynamic neural networks in Python with strong GPU acceleration
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch and Caffe2 (Shared Objects).

Package: libtorch-test
Architecture: any
Depends: libtorch1.7 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
Description: Tensors and Dynamic neural networks in Python with strong GPU acceleration
 PyTorch is a Python package that provides two high-level features:
 .
 (1) Tensor computation (like NumPy) with strong GPU acceleration
 (2) Deep neural networks built on a tape-based autograd system
 .
 You can reuse your favorite Python packages such as NumPy, SciPy and Cython
 to extend PyTorch when needed.
 .
 This is the CPU-only version of PyTorch and Caffe2 (Test Binaries).
